---
title: RTCIceServers.urls
slug: Web/API/RTCIceServer/urls
tags:
  - Experimental
  - Property
  - RTCIceServer
  - Reference
  - WebRTC
  - urls
---
<p>{{APIRef("WebRTC")}}</p>

<p>{{draft("I'm experimenting with structure for pages documenting members of dictionaries. Please contact ~~sheppy with any feedback.")}}</p>

<p>{{SeeCompatTable}}</p>

<p>The {{domxref("RTCIceServer")}} dictionary's <strong><code>urls</code></strong> property specifies the URL or URLs of the servers to be used for ICE negotiations. These are typically STUN and/or TURN servers.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var iceServer = {
                  urls = <em>iceServerUrl</em> | [ <em>url1</em>, ..., <em>urlN</em> ],
                  username: "webrtc", // optional
                  credential: "turnpassword" // optional
                };

iceServers.push(iceServer);</pre>

<p>The value of this property may be specified as a single URL or as an array of multiple URLs.</p>

<h2 id="Examples">Examples</h2>

<p>Let's look a few examples of varying complexity.</p>

<h3 id="A_single_ICE_server">A single ICE server</h3>

<p>This example creates a new {{domxref("RTCPeerConnection")}} which will use a {{Glossary("STUN")}} server at <code>stunserver.example.org</code> to negotiate connections.</p>

<pre class="brush: js">myPeerConnection = new RTCPeerConnection({
  iceServers: [
    {
      urls: "stun:stunserver.example.org"
    }
  ]
});</pre>

<p>Notice that only the <code>urls</code> property is provided; the STUN server doesn't require authentication, so this is all that's needed.</p>

<h3 id="A_single_ICE_server_with_authentication">A single ICE server with authentication</h3>

<p>The second example creates a new {{domxref("RTCPeerConnection")}} which will use a {{Glossary("TURN")}} server at <code>turnserver.example.org</code> to negotiate connections. Logging into the TURN server will use the username "webrtc" and the creative password "turnpassword".</p>

<pre class="brush: js">myPeerConnection = new RTCPeerConnection({
  iceServers: [
    {
      urls: "turn:turnserver.example.org",
      username: "webrtc",
      credential: "turnpassword"
    }
  ]
});</pre>

<h3 id="A_single_ICE_server_with_multiple_URLs">A single ICE server with multiple URLs</h3>

<p>The next example creates a new {{domxref("RTCPeerConnection")}} which will use a single {{Glossary("TURN")}} server which has multiple URLs. This is useful if the server is, for example, available both on "turn" and "turns" schemes, or if there's a fallback address available for the server.</p>

<div class="note">
<p>Keep in mind that ICE will try all the URLs you list here, so the more you include, the longer connections will take to establish.</p>
</div>

<pre class="brush: js">myPeerConnection = new RTCPeerConnection({
  iceServers: [
    {
      urls: ["turns:turnserver.example.org", "turn:turnserver.example.org"],
      username: "webrtc",
      credential: "turnpassword"
    }
  ]
});</pre>

<h3 id="Multiple_ICE_servers">Multiple ICE servers</h3>

<p>Finally, this example creates a new {{domxref("RTCPeerConnection")}} which will use one of two servers for ICE negotiation. Each server can have one or more URLs, as demonstrated above.</p>

<pre class="brush: js">myPeerConnection = new RTCPeerConnection({
  iceServers: [
    {
      urls: ["turns:turnserver.example.org", "turn:turnserver.example.org"],
      username: "webrtc",
      credential: "turnpassword"
    },
    {
      urls: "stun: stunserver.example.org"
    }
  ]
});</pre>

<p>Two ICE servers are provided. One is a TURN server which can be accessed both over TURN and TURNS. The other is a STUN server. Any number of servers could be listed of any combination of types.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-rtciceserver-urls', 'RTCIceServer.urls') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCIceServer.urls")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("RTCIceServer")}}</li>
</ul>
